'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Template = function () {
    function Template() {
        _classCallCheck(this, Template);

        this._title = 'Preleganto presentation';
        this._css = [];
        this._js = [];
        this._slides = [];
        this._metadata = {};
    }

    _createClass(Template, [{
        key: 'setTitle',
        value: function setTitle(title) {
            this._title = title;
            return this;
        }
    }, {
        key: 'setMetadata',
        value: function setMetadata(metadata) {
            this._metadata = Object.assign(this._metadata, metadata);
            return this;
        }
    }, {
        key: 'addCss',
        value: function addCss(external, content) {
            this._css.push({ external: external, content: content });
            return this;
        }
    }, {
        key: 'addJs',
        value: function addJs(external, content) {
            var options = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};

            this._js.push({ external: external, content: content, options: options });
            return this;
        }
    }, {
        key: 'addSlide',
        value: function addSlide(content) {
            this._slides.push(content);
            return this;
        }
    }, {
        key: 'toHtml',
        value: function toHtml() {
            return '<!DOCTYPE html>\n            <html>\n                <head>\n                    <meta charset="utf-8">\n                    <title>' + this._title + '</title>\n                    ' + this._css.map(this._compileCss).join('\n') + '\n                </head>\n                <body>\n                    <main class="preleganto-presentation">\n                        ' + this._slides.map(this._compileSlide).join('\n') + '\n                    </main>\n                    <script type="text/preleganto-metadata">\n                        ' + this._compileMetadata() + '\n                    </script>\n                    ' + this._js.map(this._compileJs).join('\n') + '\n                </body>\n            </html>\n        ';
        }
    }, {
        key: '_compileCss',
        value: function _compileCss(css) {
            if (css.external) {
                return '<link rel="stylesheet" href="' + css.content + '" />';
            } else {
                return '<style type="text/css">\n                ' + css.content + '\n            </style>';
            }
        }
    }, {
        key: '_compileJs',
        value: function _compileJs(js) {
            var extras = Object.keys(js.options).map(function (key) {
                var value = js.options[key];
                if (typeof value === 'string') {
                    return ' ' + key + '="' + value + '"';
                } else if (value === true) {
                    return ' ' + key;
                }
            }).join('');

            if (js.external) {
                return '<script type="text/javascript" src="' + js.content + '" ' + extras + '></script>';
            } else {
                return '<script type="text/javascript">\n                ' + js.content + '\n            </script>';
            }
        }
    }, {
        key: '_compileSlide',
        value: function _compileSlide(slide, index) {
            return '<section id="view-' + (index + 1) + '" class="preleganto-slide">\n            ' + slide + '\n        </section>';
        }
    }, {
        key: '_compileMetadata',
        value: function _compileMetadata() {
            return JSON.stringify(this._metadata);
        }
    }]);

    return Template;
}();

exports.default = Template;