'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _fs = require('fs');

var _fs2 = _interopRequireDefault(_fs);

var _ejs = require('ejs');

var _ejs2 = _interopRequireDefault(_ejs);

var _logger = require('../logger');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var DEFAULT_THEME_DIR = _path2.default.join(__dirname, '..', '..', 'themes', 'default');

var Theme = function () {
    function Theme(identifier, rootpath) {
        _classCallCheck(this, Theme);

        var themedir = void 0;
        if (identifier[0] === '.') {
            themedir = _path2.default.join(rootpath, identifier);
        } else {
            themedir = _path2.default.join(__dirname, '..', '..', 'themes', identifier);
        }

        this._content = _ejs2.default.compile(this._loadFile(themedir, 'content.html'));
        this._opening = _ejs2.default.compile(this._loadFile(themedir, 'opening.html'));
        this._closing = _ejs2.default.compile(this._loadFile(themedir, 'closing.html'));
        this._style = this._loadFile(themedir, 'style.css');
    }

    _createClass(Theme, [{
        key: 'renderContent',
        value: function renderContent(data) {
            try {
                return this._content({ data: data });
            } catch (ex) {
                (0, _logger.error)('compile error of content slide: this is an error of theme author');
                return '';
            }
        }
    }, {
        key: 'renderOpening',
        value: function renderOpening(data) {
            try {
                return this._opening({ data: data });
            } catch (ex) {
                (0, _logger.error)('compile error of content slide: this is an error of theme author');
                return '';
            }
        }
    }, {
        key: 'renderClosing',
        value: function renderClosing(data) {
            try {
                return this._closing({ data: data });
            } catch (ex) {
                (0, _logger.error)('compile error of content slide: this is an error of theme author');
                return '';
            }
        }
    }, {
        key: 'renderStyle',
        value: function renderStyle() {
            return this._style;
        }
    }, {
        key: '_loadFile',
        value: function _loadFile(themedir, asset) {
            var filepath = _path2.default.join(themedir, asset);
            try {
                if (_fs2.default.statSync(filepath).isFile()) {
                    return _fs2.default.readFileSync(filepath).toString();
                } else {
                    return _fs2.default.readFileSync(DEFAULT_THEME_DIR).toString();
                }
            } catch (ex) {
                (0, _logger.error)('load error of ' + filepath + ': you probably specified non-existent theme or its location');
                return '';
            }
        }
    }]);

    return Theme;
}();

exports.default = Theme;