'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.IMPLEMENTATION_ERROR_MESSAGE = undefined;
exports.log = log;
exports.warn = warn;
exports.error = error;
exports.newline = newline;
exports.logo = logo;

var _chalk = require('chalk');

var _chalk2 = _interopRequireDefault(_chalk);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var IMPLEMENTATION_ERROR_MESSAGE = exports.IMPLEMENTATION_ERROR_MESSAGE = 'This is an implementation error. I will try to go on but the results are ' + 'undefined. Please fill an issue on https://github.com/pnevyk/preleganto.';

function log(message) {
    process.stdout.write(_chalk2.default.cyan('[preleganto]') + ' ' + _chalk2.default.gray(message) + '\n');
}

function warn(message) {
    process.stderr.write(_chalk2.default.cyan('[preleganto ' + _chalk2.default.yellow('warning') + ']') + ' ' + _chalk2.default.gray(message) + '\n');
}

function error(message) {
    process.stderr.write(_chalk2.default.cyan('[preleganto ' + _chalk2.default.red('error') + ']') + ' ' + _chalk2.default.gray(message) + '\n');
    process.exit(1);
}

function newline() {
    var error = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;

    if (error) {
        process.stderr.write('\n');
    } else {
        process.stdout.write('\n');
    }
}

function logo() {
    /* eslint-disable */
    var text = "  _____          _                        _        \n" + " |  __ \\        | |                      | |       \n" + " | |__) | __ ___| | ___  __ _  __ _ _ __ | |_ ___  \n" + " |  ___/ '__/ _ \\ |/ _ \\/ _` |/ _` | '_ \\| __/ _ \\ \n" + " | |   | | |  __/ |  __/ (_| | (_| | | | | || (_) |\n" + " |_|   |_|  \\___|_|\\___|\\__, |\\__,_|_| |_|\\__\\___/ \n" + "                         __/ |                     \n" + "                        |___/                      \n";
    /* eslint-enable */

    process.stdout.write('\n' + _chalk2.default.gray(text) + '\n');
}