'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _fs = require('fs');

var _fs2 = _interopRequireDefault(_fs);

var _express = require('express');

var _express2 = _interopRequireDefault(_express);

var _http = require('http');

var _http2 = _interopRequireDefault(_http);

var _ws = require('ws');

var _ws2 = _interopRequireDefault(_ws);

var _chalk = require('chalk');

var _chalk2 = _interopRequireDefault(_chalk);

var _logger = require('./logger');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Server = function () {
    function Server(options) {
        _classCallCheck(this, Server);

        this._options = options;
    }

    _createClass(Server, [{
        key: 'run',
        value: function run(filepath) {
            var _this = this;

            var app = (0, _express2.default)();

            app.get(/.*/, function (req, res) {
                // load file on each request since it could be rebuilt
                res.send(_fs2.default.readFileSync(filepath).toString());
            });

            this._server = _http2.default.createServer(app);
            this._wss = new _ws2.default.Server({ server: this._server });

            this._wss.on('connection', function (socket) {
                (0, _logger.log)('Someone has connected');
                socket.on('message', function (action) {
                    _this._wss.clients.forEach(function (client) {
                        if (client !== socket && client.readyState === _ws2.default.OPEN) {
                            client.send(action);
                        }
                    });
                });
            });

            this._server.listen(this._options.port);
            this._server.on('listening', function () {
                // use server.address().port because when port given by user is invalid, server can assign different port
                var address = _chalk2.default.magenta('http://localhost:' + _this._server.address().port);
                (0, _logger.log)('Local server is running at ' + address);
                (0, _logger.newline)();
            });
        }
    }, {
        key: 'reloadClients',
        value: function reloadClients() {
            var action = JSON.stringify({ name: 'reload' });

            (0, _logger.log)('I am asking all connected clients to reload');
            this._wss.clients.forEach(function (client) {
                if (client.readyState === _ws2.default.OPEN) {
                    client.send(action);
                }
            });
        }
    }]);

    return Server;
}();

exports.default = Server;